function result = calc_emd(orig, recovered, cheat)
% result = [sum_of_distance_between_centroids
% sum_of_differences_in_magnitude
% whether_or_not_we_even_recovered_enough_stars_to_make_the_first_two_numbe
% rs_mean_anything]

global C

stars = sortrows(centroiderUnifStars(orig),-3);
%stars = stars(1:numstars, :);

if nargin < 3, cheat = 0; end 
if cheat ~= 0
	recstars = centroiderPyr(recovered, stars(:,1:2), C.starwidth*5);
	dist = recstars - stars .* (recstars ~= 0);
	result(1) = sum((dist(:,1).^2 + dist(:,2).^2).^(.5));
	result(2) = sum(dist(:,3));
	result(3) = ~isempty(find(recstars(:,3) == 0, 1));
	if result(3) == 1, fprintf('RECOVERED TOO FEW STARS!!\n'), end
	return
end

recstars = sortrows(centroiderUnifStars(recovered),-3);
if numel(recstars) == 0  %don't crash if no stars found
  recstars = [0 0 0];
end
dists = pdist2(stars(:,1:2), recstars(:,1:2), 'euclidean');
[dist, match] = min(dists, [], 2);
result(1) = sum(dist);
result(2) = norm(recstars(match,3) - stars(:,3),1);

if numel(unique(match)) ~= C.numstars || ~isempty(find(recstars(:,3)==0, 1))
	fprintf('FAIL IN calc_emd -- DIDNT FIND ENOUGH STARS.\n');
	result(3) = 1;
else
	result(3) = 0;
end

