function starList = centroiderPyr(pic, hint, hintradius)

global C

% size(hint) = [2, C.numstars]
piccopy = pic;
cutoffs = prctile(pic(:), [85:1:99 99:.1:99.9]);

function [ctrx,ctry] = centroid_star(pic,pts)
% if nargin == 1,	pts = 1:numel(pic); end
[X,Y] = ind2sub(size(pic),pts);
ctr = [sum(X.* pic(pts)), sum(Y.* pic(pts))] / sum(pic(pts));
% +.5 because the center of the pixel is (.5,.5) away 
ctrx = ctr(1) + .5;
ctry = ctr(2) + .5;
end

if nargin > 2
	dims = size(pic);
	starList = zeros(C.numstars, 3);
	cutoff = prctile(pic(:), 90);
	pic  = (pic > cutoff) .* pic;
	for i = 1:C.numstars
		fx = max(floor(hint(i,1)-hintradius), 1);
		cx = min(ceil(hint(i,1)+hintradius), dims(1));
		fy = max(floor(hint(i,2)-hintradius), 1);
		cy = min(ceil(hint(i,2)+hintradius), dims(2));
		starList(i,:) = getctr(pic, fx:cx, fy:cy);		
		starList(i,3) = sum(sum(pic(fx:cx, fy:cy)));
		if starList(i,3) < 1000, 
			starList(i,:) = 0;
			continue; 
		end
	end
	return;
end
pixelcutoff = 5;
	
cc = bwconncomp(pic > cutoffs(1), 4);
toosmall = cellfun(@(blob) numel(blob) < pixelcutoff, cc.PixelIdxList);
for j = find(toosmall)
	pic(cc.PixelIdxList{j}) = 0;
end
cc = bwconncomp(pic, 4);
stars = cc.PixelIdxList;

i = 2;
while numel(stars) < C.numstars && i <= numel(cutoffs)	
	% clean out all small lumps
	cc = bwconncomp(pic > cutoffs(i), 4);
	toosmall = cellfun(@(blob) numel(blob) < pixelcutoff, cc.PixelIdxList);
	for j = find(toosmall)
		pic(cc.PixelIdxList{j}) = 0;
	end
	cc = bwconncomp(pic > cutoffs(i), 4);
	if cc.NumObjects > numel(stars)
		match = 0;
		for j = 1:numel(stars)
			for k = 1:cc.NumObjects
				match(j,k) = ~isempty(find(stars{j} == cc.PixelIdxList{k}(1), 1));
			end
		end
		splits = sum(match, 2);
		count = 1;
		newstars = {};
		for j = 1:numel(stars)
			if splits(j) == 1
				newstars{count} = stars{j};
				count = count+1;
			else
				for k = find(match(j,:))
					newstars{count} = cc.PixelIdxList{k};
					count = count+1;
				end
			end
		end
		stars = newstars;
	end
	i = i+1;
end

if i > numel(cutoffs)
	fprintf('FAIL in centroiderPyr.m\n');
end

[ctrsx, ctrsy] = cellfun(@(blob) centroid_star(piccopy, blob), stars);
mags = cellfun(@(blob) sum(piccopy(blob)), stars);
starList = [ctrsx' ctrsy' mags'];
sortrows(starList, -3);
starList = starList(1:5,:);

end