function starList = centroiderUnifStars(pic)
global C

function starctr = getctr(image, xrange, yrange)
	starctr(3) = sum(sum(image(xrange, yrange)));
	if starctr(3) == 0, return; end
	starctr(1) = sum(xrange * image(xrange,yrange)) / starctr(3) + .5;
	starctr(2) = sum(image(xrange, yrange) * yrange') / starctr(3) + .5;
end

starList = zeros(C.numstars, 3);
pic = pic .* (pic > prctile(pic(:), 85));
trialnum = 1;
i = 1;

while (trialnum < 3 * C.numstars) && (i <= C.numstars)
	[xxx coord] = max(pic(:));
	[x y] = ind2sub(size(pic), coord);
	
	for j = 1:3
		radius = C.starwidth * 5;
		fx = max(floor(x-radius), 1);
		cx = min(ceil(x+radius), C.n_pixel);
		fy = max(floor(y-radius), 1);
		cy = min(ceil(y+radius), C.n_pixel);
		starList(i,:) = getctr(pic, fx:cx, fy:cy);
		x = starList(i,1);
		y = starList(i,2);
	end
	
	if starList(i,3) < C.numphotons/25
		starList(i,:) = 0;
		fx = max(floor(x-2), 1);
		cx = min(ceil(x+2), C.n_pixel);
		fy = max(floor(y-2), 1);
		cy = min(ceil(y+2), C.n_pixel);
		pic(fx:cx, fy:cy) = 0;
	else
		pic(fx:cx, fy:cy) = 0;
		i = i+1;
	end
	trialnum = trialnum + 1;
end

end
