% generates a binary sparse matrix for modular folding

function matrix = gen_matrix_rishimod(N, M, q1, q2)

matrix.N = N;
matrix.M = q1^2+q2^2;
%matrix.D = 2;

%disp([ 'Creating matrix for M = ' num2str(M) ', D = ' num2str(D) '...']);

piclen = round(sqrt(N));

[I,J] = ind2sub([piclen,piclen],1:N);
i = [sub2ind([q1,q1],mod(I-1,q1)+1,mod(J-1,q1)+1) ...
     sub2ind([q2,q2],mod(I-1,q2)+1,mod(J-1,q2)+1)+q1^2 ];

matrix.A = sparse(i,[1:N 1:N],ones(1,2*N));

%matrix.A = sparse(L, C, 1, M, N); 

matrix.Afun  = @(z) binsparsemul(matrix.A, z);
matrix.Atfun = @(z) binsparsemul(matrix.A', z);

%matrix.MedianRecoveryFun = @(z) median_recovery_explicit(N, M, D, matrix.neighbors, z);

